// D import file generated from 'derelict/sdl2/functions.d'
module derelict.sdl2.functions;
private 
{
	import core.stdc.stdio;
	import core.stdc.stdarg;
	import derelict.util.system;
	import derelict.sdl2.types;
}
extern (C) nothrow @nogc 
{
	alias int function(Uint32) da_SDL_Init;
	alias int function(Uint32) da_SDL_InitSubSystem;
	alias void function(Uint32) da_SDL_QuitSubSystem;
	alias Uint32 function(Uint32) da_SDL_WasInit;
	alias void function() da_SDL_Quit;
	alias void function(void* mem) da_SDL_free;
	alias void function(SDL_AssertionHandler, void*) da_SDL_SetAssertionHandler;
	alias const(SDL_assert_data)* function() da_SDL_GetAssertionReport;
	alias void function() da_SDL_ResetAssertionReport;
	alias int function() da_SDL_GetNumAudioDrivers;
	alias const(char)* function(int) da_SDL_GetAudioDriver;
	alias int function(const(char)*) da_SDL_AudioInit;
	alias void function() da_SDL_AudioQuit;
	alias const(char)* function() da_SDL_GetCurrentAudioDriver;
	alias int function(SDL_AudioSpec*, SDL_AudioSpec*) da_SDL_OpenAudio;
	alias int function(int) da_SDL_GetNumAudioDevices;
	alias const(char)* function(int, int) da_SDL_GetAudioDeviceName;
	alias SDL_AudioDeviceID function(const(char)*, int, const(SDL_AudioSpec)*, SDL_AudioSpec*, int) da_SDL_OpenAudioDevice;
	alias SDL_AudioStatus function() da_SDL_GetAudioStatus;
	alias SDL_AudioStatus function(SDL_AudioDeviceID) da_SDL_GetAudioDeviceStatus;
	alias void function(int) da_SDL_PauseAudio;
	alias void function(SDL_AudioDeviceID, int) da_SDL_PauseAudioDevice;
	alias SDL_AudioSpec* function(SDL_RWops*, int, SDL_AudioSpec*, Uint8**, Uint32*) da_SDL_LoadWAV_RW;
	alias void function(Uint8*) da_SDL_FreeWAV;
	alias int function(SDL_AudioCVT*, SDL_AudioFormat, Uint8, int, SDL_AudioFormat, Uint8, int) da_SDL_BuildAudioCVT;
	alias int function(SDL_AudioCVT*) da_SDL_ConvertAudio;
	alias void function(Uint8*, const(Uint8)*, Uint32, int) da_SDL_MixAudio;
	alias void function(Uint8*, const(Uint8)*, SDL_AudioFormat, Uint32, int) da_SDL_MixAudioFormat;
	alias void function() da_SDL_LockAudio;
	alias void function(SDL_AudioDeviceID) da_SDL_LockAudioDevice;
	alias void function() da_SDL_UnlockAudio;
	alias void function(SDL_AudioDeviceID) da_SDL_UnlockAudioDevice;
	alias void function() da_SDL_CloseAudio;
	alias void function(SDL_AudioDeviceID) da_SDL_CloseAudioDevice;
	alias int function(SDL_AudioDeviceID) da_SDL_AudioDeviceConnected;
	alias int function(const(char)*) da_SDL_SetClipboardText;
	alias char* function() da_SDL_GetClipboardText;
	alias SDL_bool function() da_SDL_HasClipboardText;
	alias int function() da_SDL_GetCPUCount;
	alias int function() da_SDL_GetCPUCacheLineSize;
	alias SDL_bool function() da_SDL_HasRDTSC;
	alias SDL_bool function() da_SDL_HasAltiVec;
	alias SDL_bool function() da_SDL_HasMMX;
	alias SDL_bool function() da_SDL_Has3DNow;
	alias SDL_bool function() da_SDL_HasSSE;
	alias SDL_bool function() da_SDL_HasSSE2;
	alias SDL_bool function() da_SDL_HasSSE3;
	alias SDL_bool function() da_SDL_HasSSE41;
	alias SDL_bool function() da_SDL_HasSSE42;
	alias SDL_bool function() da_SDL_HasAVX;
	alias int function() da_SDL_GetSystemRAM;
	alias void function(const(char)*, ...) da_SDL_SetError;
	alias const(char)* function() da_SDL_GetError;
	alias void function() da_SDL_ClearError;
	alias void function() da_SDL_PumpEvents;
	alias int function(SDL_Event*, int, SDL_eventaction, Uint32, Uint32) da_SDL_PeepEvents;
	alias SDL_bool function(Uint32) da_SDL_HasEvent;
	alias SDL_bool function(Uint32, Uint32) da_SDL_HasEvents;
	alias void function(Uint32) da_SDL_FlushEvent;
	alias void function(Uint32, Uint32) da_SDL_FlushEvents;
	alias int function(SDL_Event*) da_SDL_PollEvent;
	alias int function(SDL_Event*) da_SDL_WaitEvent;
	alias int function(SDL_Event*, int) da_SDL_WaitEventTimeout;
	alias int function(SDL_Event*) da_SDL_PushEvent;
	alias void function(SDL_EventFilter, void*) da_SDL_SetEventFilter;
	alias void function(SDL_EventFilter*, void**) da_SDL_GetEventFilter;
	alias void function(SDL_EventFilter, void*) da_SDL_AddEventWatch;
	alias void function(SDL_EventFilter, void*) da_SDL_DelEventWatch;
	alias void function(SDL_EventFilter, void*) da_SDL_FilterEvents;
	alias Uint8 function(Uint32, int) da_SDL_EventState;
	alias Uint32 function(int) da_SDL_RegisterEvents;
	alias int function(SDL_RWops*, int) da_SDL_GameControllerAddMappingsFromRW;
	alias int function(const(char)*) da_SDL_GameControllerAddMapping;
	alias char* function(SDL_JoystickGUID) da_SDL_GameControllerMappingForGUID;
	alias char* function(SDL_GameController*) da_SDL_GameControllerMapping;
	alias SDL_bool function(int) da_SDL_IsGameController;
	alias const(char)* function(int) da_SDL_GameControllerNameForIndex;
	alias SDL_GameController* function(int) da_SDL_GameControllerOpen;
	alias const(char)* function(SDL_GameController*) da_SDL_GameControllerName;
	alias SDL_bool function(SDL_GameController*) da_SDL_GameControllerGetAttached;
	alias SDL_Joystick* function(SDL_GameController*) da_SDL_GameControllerGetJoystick;
	alias int function(int) da_SDL_GameControllerEventState;
	alias void function() da_SDL_GameControllerUpdate;
	alias SDL_GameControllerAxis function(const(char)*) da_SDL_GameControllerGetAxisFromString;
	alias const(char)* function(SDL_GameControllerAxis) da_SDL_GameControllerGetStringForAxis;
	alias SDL_GameControllerButtonBind function(SDL_GameController*, SDL_GameControllerAxis) da_SDL_GameControllerGetBindForAxis;
	alias Sint16 function(SDL_GameController*, SDL_GameControllerAxis) da_SDL_GameControllerGetAxis;
	alias SDL_GameControllerButton function(const(char*)) da_SDL_GameControllerGetButtonFromString;
	alias const(char)* function(SDL_GameControllerButton) da_SDL_GameControllerGetStringForButton;
	alias SDL_GameControllerButtonBind function(SDL_GameController*, SDL_GameControllerButton) da_SDL_GameControllerGetBindForButton;
	alias Uint8 function(SDL_GameController*, SDL_GameControllerButton) da_SDL_GameControllerGetButton;
	alias void function(SDL_GameController*) da_SDL_GameControllerClose;
	alias int function(SDL_TouchID) da_SDL_RecordGesture;
	alias int function(SDL_RWops*) da_SDL_SaveAllDollarTemplates;
	alias int function(SDL_GestureID, SDL_RWops*) da_SDL_SaveDollarTemplate;
	alias int function(SDL_TouchID, SDL_RWops*) da_SDL_LoadDollarTemplates;
	alias int function() da_SDL_NumHaptics;
	alias const(char)* function(int) da_SDL_HapticName;
	alias SDL_Haptic* function(int) da_SDL_HapticOpen;
	alias int function(int) da_SDL_HapticOpened;
	alias int function(SDL_Haptic*) da_SDL_HapticIndex;
	alias int function() da_SDL_MouseIsHaptic;
	alias SDL_Haptic* function() da_SDL_HapticOpenFromMouse;
	alias int function(SDL_Joystick*) da_SDL_JoystickIsHaptic;
	alias SDL_Haptic* function(SDL_Joystick*) da_SDL_HapticOpenFromJoystick;
	alias int function(SDL_Haptic*) da_SDL_HapticClose;
	alias int function(SDL_Haptic*) da_SDL_HapticNumEffects;
	alias int function(SDL_Haptic*) da_SDL_HapticNumEffectsPlaying;
	alias uint function(SDL_Haptic*) da_SDL_HapticQuery;
	alias int function(SDL_Haptic*) da_SDL_HapticNumAxes;
	alias int function(SDL_Haptic*, SDL_HapticEffect*) da_SDL_HapticEffectSupported;
	alias int function(SDL_Haptic*, SDL_HapticEffect*) da_SDL_HapticNewEffect;
	alias int function(SDL_Haptic*, int, SDL_HapticEffect*) da_SDL_HapticUpdateEffect;
	alias int function(SDL_Haptic*, int, SDL_HapticEffect*) da_SDL_HapticRunEffect;
	alias int function(SDL_Haptic*, int) da_SDL_HapticStopEffect;
	alias int function(SDL_Haptic*, int) da_SDL_HapticDestroyEffect;
	alias int function(SDL_Haptic*, int) da_SDL_HapticGetEffectStatus;
	alias int function(SDL_Haptic*, int) da_SDL_HapticSetGain;
	alias int function(SDL_Haptic*, int) da_SDL_HapticSetAutocenter;
	alias int function(SDL_Haptic*) da_SDL_HapticPause;
	alias int function(SDL_Haptic*) da_SDL_HapticUnpause;
	alias int function(SDL_Haptic*) da_SDL_HapticStopAll;
	alias int function(SDL_Haptic*) da_SDL_HapticRumbleSupported;
	alias int function(SDL_Haptic*) da_SDL_HapticRumbleInit;
	alias int function(SDL_Haptic*, float, Uint32) da_SDL_HapticRumblePlay;
	alias int function(SDL_Haptic*) da_SDL_HapticRumbleStop;
	alias SDL_bool function(const(char)*, const(char)*, SDL_HintPriority) da_SDL_SetHintWithPriority;
	alias SDL_bool function(const(char)*, const(char)*) da_SDL_SetHint;
	alias const(char)* function(const(char)*) da_SDL_GetHint;
	alias void function(const(char)*, SDL_HintCallback, void*) da_SDL_AddHintCallback;
	alias void function(const(char)*, SDL_HintCallback, void*) da_SDL_DelHintCallback;
	alias void function() da_SDL_ClearHints;
	alias int function() da_SDL_RedetectInputDevices;
	alias int function() da_SDL_GetNumInputDevices;
	alias const(char)* function(int) da_SDL_GetInputDeviceName;
	alias int function(int) da_SDL_IsDeviceDisconnected;
	alias int function() da_SDL_NumJoysticks;
	alias const(char)* function(int) da_SDL_JoystickNameForIndex;
	alias SDL_Joystick* function(int) da_SDL_JoystickOpen;
	alias const(char)* function(SDL_Joystick*) da_SDL_JoystickName;
	alias JoystickGUID function(int) da_SDL_JoystickGetDeviceGUID;
	alias JoystickGUID function(SDL_Joystick*) da_SDL_JoystickGetGUID;
	alias char* function(JoystickGUID) da_SDL_JoystickGetGUIDString;
	alias JoystickGUID function(const(char)*) da_SDL_JoystickGetGUIDFromString;
	alias SDL_bool function(SDL_Joystick*) da_SDL_JoystickGetAttached;
	alias SDL_JoystickID function(SDL_Joystick*) da_SDL_JoystickInstanceID;
	alias int function(SDL_Joystick*) da_SDL_JoystickNumAxes;
	alias int function(SDL_Joystick*) da_SDL_JoystickNumBalls;
	alias int function(SDL_Joystick*) da_SDL_JoystickNumHats;
	alias int function(SDL_Joystick*) da_SDL_JoystickNumButtons;
	alias void function() da_SDL_JoystickUpdate;
	alias int function(int) da_SDL_JoystickEventState;
	alias Sint16 function(SDL_Joystick*, int) da_SDL_JoystickGetAxis;
	alias Uint8 function(SDL_Joystick*, int) da_SDL_JoystickGetHat;
	alias int function(SDL_Joystick*, int, int*, int*) da_SDL_JoystickGetBall;
	alias Uint8 function(SDL_Joystick*, int) da_SDL_JoystickGetButton;
	alias void function(SDL_Joystick*) da_SDL_JoystickClose;
	alias SDL_Window* function() da_SDL_GetKeyboardFocus;
	alias Uint8* function(int*) da_SDL_GetKeyboardState;
	alias SDL_Keymod function() da_SDL_GetModState;
	alias void function(SDL_Keymod) da_SDL_SetModState;
	alias SDL_Keycode function(SDL_Scancode) da_SDL_GetKeyFromScancode;
	alias SDL_Scancode function(SDL_Keycode) da_SDL_GetScancodeFromKey;
	alias const(char)* function(SDL_Scancode) da_SDL_GetScancodeName;
	alias SDL_Scancode function(const(char)*) da_SDL_GetScancodeFromName;
	alias const(char)* function(SDL_Keycode) da_SDL_GetKeyName;
	alias SDL_Keycode function(const(char)*) da_SDL_GetKeyFromName;
	alias void function() da_SDL_StartTextInput;
	alias SDL_bool function() da_SDL_IsTextInputActive;
	alias void function() da_SDL_StopTextInput;
	alias void function(SDL_Rect*) da_SDL_SetTextInputRect;
	alias SDL_bool function() da_SDL_HasScreenKeyboardSupport;
	alias SDL_bool function(SDL_Window*) da_SDL_IsScreenKeyboardShown;
	alias void* function(const(char)*) da_SDL_LoadObject;
	alias void* function(void*, const(char*)) da_SDL_LoadFunction;
	alias void function(void*) da_SDL_UnloadObject;
	alias void function(SDL_LogPriority) da_SDL_LogSetAllPriority;
	alias void function(int, SDL_LogPriority) da_SDL_LogSetPriority;
	alias SDL_LogPriority function(int) da_SDL_LogGetPriority;
	alias void function() da_SDL_LogResetPriorities;
	alias void function(const(char)*, ...) da_SDL_Log;
	alias void function(int, const(char)*, ...) da_SDL_LogVerbose;
	alias void function(int, const(char)*, ...) da_SDL_LogDebug;
	alias void function(int, const(char)*, ...) da_SDL_LogInfo;
	alias void function(int, const(char)*, ...) da_SDL_LogWarn;
	alias void function(int, const(char)*, ...) da_SDL_LogError;
	alias void function(int, const(char)*, ...) da_SDL_LogCritical;
	alias void function(int, SDL_LogPriority, const(char)*, ...) da_SDL_LogMessage;
	alias void function(int, SDL_LogPriority, const(char)*, va_list) da_SDL_LogMessageV;
	alias void function(SDL_LogOutputFunction, void**) da_SDL_LogGetOutputFunction;
	alias void function(SDL_LogOutputFunction, void*) da_SDL_LogSetOutputFunction;
	alias int function(const(SDL_MessageBoxData)*, int*) da_SDL_ShowMessageBox;
	alias int function(Uint32, const(char)*, const(char)*, SDL_Window*) da_SDL_ShowSimpleMessageBox;
	alias SDL_Window* function() da_SDL_GetMouseFocus;
	alias Uint32 function(int*, int*) da_SDL_GetMouseState;
	alias Uint32 function(int*, int*) da_SDL_GetRelativeMouseState;
	alias void function(SDL_Window*, int, int) da_SDL_WarpMouseInWindow;
	alias int function(SDL_bool) da_SDL_SetRelativeMouseMode;
	alias SDL_bool function() da_SDL_GetRelativeMouseMode;
	alias SDL_Cursor* function(const(Uint8)*, const(Uint8)*, int, int, int, int) da_SDL_CreateCursor;
	alias SDL_Cursor* function(SDL_Surface*, int, int) da_SDL_CreateColorCursor;
	alias SDL_Cursor* function(SDL_SystemCursor) da_SDL_CreateSystemCursor;
	alias void function(SDL_Cursor*) da_SDL_SetCursor;
	alias SDL_Cursor* function() da_SDL_GetCursor;
	alias SDL_Cursor* function() da_SDL_GetDefaultCursor;
	alias void function(SDL_Cursor*) da_SDL_FreeCursor;
	alias int function(int) da_SDL_ShowCursor;
	alias const(char)* function(Uint32) da_SDL_GetPixelFormatName;
	alias SDL_bool function(Uint32, int*, Uint32*, Uint32*, Uint32*, Uint32*) da_SDL_PixelFormatEnumToMasks;
	alias Uint32 function(int, Uint32, Uint32, Uint32, Uint32) da_SDL_MasksToPixelFormatEnum;
	alias SDL_PixelFormat* function(Uint32) da_SDL_AllocFormat;
	alias void function(SDL_PixelFormat*) da_SDL_FreeFormat;
	alias SDL_Palette* function(int) da_SDL_AllocPalette;
	alias int function(SDL_PixelFormat*, SDL_Palette*) da_SDL_SetPixelFormatPalette;
	alias int function(SDL_Palette*, const(SDL_Color)*, int, int) da_SDL_SetPaletteColors;
	alias void function(SDL_Palette*) da_SDL_FreePalette;
	alias Uint32 function(const(SDL_PixelFormat)*, Uint8, Uint8, Uint8) da_SDL_MapRGB;
	alias Uint32 function(const(SDL_PixelFormat)*, Uint8, Uint8, Uint8, Uint8) da_SDL_MapRGBA;
	alias void function(Uint32, const(SDL_PixelFormat)*, Uint8*, Uint8*, Uint8*) da_SDL_GetRGB;
	alias void function(Uint32, const(SDL_PixelFormat)*, Uint8*, Uint8*, Uint8*, Uint8*) da_SDL_GetRGBA;
	alias void function(float, Uint16*) da_SDL_CalculateGammaRamp;
	alias const(char)* function() da_SDL_GetPlatform;
	alias SDL_PowerState function(int*, int*) da_SDL_GetPowerInfo;
	alias SDL_bool function(const(SDL_Rect)*, const(SDL_Rect)*) da_SDL_HasIntersection;
	alias SDL_bool function(const(SDL_Rect)*, const(SDL_Rect)*, SDL_Rect*) da_SDL_IntersectRect;
	alias void function(const(SDL_Rect)*, const(SDL_Rect)*, SDL_Rect*) da_SDL_UnionRect;
	alias void function(const(SDL_Point)*, int, const(SDL_Rect)*, SDL_Rect*) da_SDL_EnclosePoints;
	alias SDL_bool function(const(SDL_Rect)*, int*, int*, int*, int*) da_SDL_IntersectRectAndLine;
	alias int function() da_SDL_GetNumRenderDrivers;
	alias int function(int, SDL_RendererInfo*) da_SDL_GetRenderDriverInfo;
	alias int function(int, int, Uint32, SDL_Window**, SDL_Renderer**) da_SDL_CreateWindowAndRenderer;
	alias SDL_Renderer* function(SDL_Window*, int, Uint32) da_SDL_CreateRenderer;
	alias SDL_Renderer* function(SDL_Surface*) da_SDL_CreateSoftwareRenderer;
	alias SDL_Renderer* function(SDL_Window*) da_SDL_GetRenderer;
	alias int function(SDL_Renderer*, SDL_RendererInfo*) da_SDL_GetRendererInfo;
	alias int function(SDL_Renderer*, int*, int*) da_SDL_GetRendererOutputSize;
	alias SDL_Texture* function(SDL_Renderer*, Uint32, int, int, int) da_SDL_CreateTexture;
	alias SDL_Texture* function(SDL_Renderer*, SDL_Surface*) da_SDL_CreateTextureFromSurface;
	alias int function(SDL_Texture*, Uint32*, int*, int*, int*) da_SDL_QueryTexture;
	alias int function(SDL_Texture*, Uint8, Uint8, Uint8) da_SDL_SetTextureColorMod;
	alias int function(SDL_Texture*, Uint8*, Uint8*, Uint8*) da_SDL_GetTextureColorMod;
	alias int function(SDL_Texture*, Uint8) da_SDL_SetTextureAlphaMod;
	alias int function(SDL_Texture*, Uint8*) da_SDL_GetTextureAlphaMod;
	alias int function(SDL_Texture*, SDL_BlendMode) da_SDL_SetTextureBlendMode;
	alias int function(SDL_Texture*, SDL_BlendMode*) da_SDL_GetTextureBlendMode;
	alias int function(SDL_Texture*, const(SDL_Rect)*, const(void)*, int) da_SDL_UpdateTexture;
	alias int function(SDL_Texture*, const(SDL_Rect)*, const(Uint8)*, int, const(Uint8)*, int, const(Uint8)*, int) da_SDL_UpdateYUVTexture;
	alias int function(SDL_Texture*, const(SDL_Rect)*, void**, int*) da_SDL_LockTexture;
	alias int function(SDL_Texture*) da_SDL_UnlockTexture;
	alias SDL_bool function(SDL_Renderer*) da_SDL_RenderTargetSupported;
	alias int function(SDL_Renderer*, SDL_Texture*) da_SDL_SetRenderTarget;
	alias SDL_Texture* function(SDL_Renderer*) da_SDL_GetRenderTarget;
	alias int function(SDL_Renderer*, const(SDL_Rect)*) da_SDL_RenderSetClipRect;
	alias void function(SDL_Renderer* renderer, SDL_Rect*) da_SDL_RenderGetClipRect;
	alias int function(SDL_Renderer*, int, int) da_SDL_RenderSetLogicalSize;
	alias void function(SDL_Renderer*, int*, int*) da_SDL_RenderGetLogicalSize;
	alias int function(SDL_Renderer*, const(SDL_Rect)*) da_SDL_RenderSetViewport;
	alias void function(SDL_Renderer*, SDL_Rect*) da_SDL_RenderGetViewport;
	alias int function(SDL_Renderer*, float, float) da_SDL_RenderSetScale;
	alias int function(SDL_Renderer*, float*, float*) da_SDL_RenderGetScale;
	alias int function(SDL_Renderer*, Uint8, Uint8, Uint8, Uint8) da_SDL_SetRenderDrawColor;
	alias int function(SDL_Renderer*, Uint8*, Uint8*, Uint8*, Uint8*) da_SDL_GetRenderDrawColor;
	alias int function(SDL_Renderer*, SDL_BlendMode) da_SDL_SetRenderDrawBlendMode;
	alias int function(SDL_Renderer*, SDL_BlendMode*) da_SDL_GetRenderDrawBlendMode;
	alias int function(SDL_Renderer*) da_SDL_RenderClear;
	alias int function(SDL_Renderer*, int, int) da_SDL_RenderDrawPoint;
	alias int function(SDL_Renderer*, const(SDL_Point)*, int) da_SDL_RenderDrawPoints;
	alias int function(SDL_Renderer*, int, int, int, int) da_SDL_RenderDrawLine;
	alias int function(SDL_Renderer*, const(SDL_Point)*, int) da_SDL_RenderDrawLines;
	alias int function(SDL_Renderer*, const(SDL_Rect)*) da_SDL_RenderDrawRect;
	alias int function(SDL_Renderer*, const(SDL_Rect)*, int) da_SDL_RenderDrawRects;
	alias int function(SDL_Renderer*, const(SDL_Rect)*) da_SDL_RenderFillRect;
	alias int function(SDL_Renderer*, const(SDL_Rect)*, int) da_SDL_RenderFillRects;
	alias int function(SDL_Renderer*, SDL_Texture*, const(SDL_Rect)*, const(SDL_Rect*)) da_SDL_RenderCopy;
	alias int function(SDL_Renderer*, SDL_Texture*, const(SDL_Rect)*, const(SDL_Rect)*, const(double), const(SDL_Point)*, const(SDL_RendererFlip)) da_SDL_RenderCopyEx;
	alias int function(SDL_Renderer*, const(SDL_Rect)*, Uint32, void*, int) da_SDL_RenderReadPixels;
	alias void function(SDL_Renderer*) da_SDL_RenderPresent;
	alias void function(SDL_Texture*) da_SDL_DestroyTexture;
	alias void function(SDL_Renderer*) da_SDL_DestroyRenderer;
	alias int function(SDL_Texture*, float*, float*) da_SDL_GL_BindTexture;
	alias int function(SDL_Texture*) da_SDL_GL_UnbindTexture;
	alias SDL_RWops* function(const(char)*, const(char)*) da_SDL_RWFromFile;
	alias SDL_RWops* function(FILE*, SDL_bool) da_SDL_RWFromFP;
	alias SDL_RWops* function(void*, int) da_SDL_RWFromMem;
	alias SDL_RWops* function(const(void)*, int) da_SDL_RWFromConstMem;
	alias SDL_RWops* function() da_SDL_AllocRW;
	alias void function(SDL_RWops*) da_SDL_FreeRW;
	alias Uint8 function(SDL_RWops*) da_SDL_ReadU8;
	alias Uint16 function(SDL_RWops*) da_SDL_ReadLE16;
	alias Uint16 function(SDL_RWops*) da_SDL_ReadBE16;
	alias Uint32 function(SDL_RWops*) da_SDL_ReadLE32;
	alias Uint32 function(SDL_RWops*) da_SDL_ReadBE32;
	alias Uint64 function(SDL_RWops*) da_SDL_ReadLE64;
	alias Uint64 function(SDL_RWops*) da_SDL_ReadBE64;
	alias size_t function(SDL_RWops*, Uint8) da_SDL_WriteU8;
	alias size_t function(SDL_RWops*, Uint16) da_SDL_WriteLE16;
	alias size_t function(SDL_RWops*, Uint16) da_SDL_WriteBE16;
	alias size_t function(SDL_RWops*, Uint32) da_SDL_WriteLE32;
	alias size_t function(SDL_RWops*, Uint32) da_SDL_WriteBE32;
	alias size_t function(SDL_RWops*, Uint64) da_SDL_WriteLE64;
	alias size_t function(SDL_RWops*, Uint64) da_SDL_WriteBE64;
	alias SDL_Window* function(const(char)*, uint, uint, uint, uint, Uint32) da_SDL_CreateShapedWindow;
	alias SDL_bool function(const(SDL_Window)*) da_SDL_IsShapedWindow;
	alias int function(SDL_Window*, SDL_Surface*, SDL_WindowShapeMode*) da_SDL_SetWindowShape;
	alias int function(SDL_Window*, SDL_WindowShapeMode*) da_SDL_GetShapedWindowMode;
	alias SDL_Surface* function(Uint32, int, int, int, Uint32, Uint32, Uint32, Uint32) da_SDL_CreateRGBSurface;
	alias SDL_Surface* function(void*, int, int, int, int, Uint32, Uint32, Uint32, Uint32) da_SDL_CreateRGBSurfaceFrom;
	alias void function(SDL_Surface*) da_SDL_FreeSurface;
	alias int function(SDL_Surface*, SDL_Palette*) da_SDL_SetSurfacePalette;
	alias int function(SDL_Surface*) da_SDL_LockSurface;
	alias int function(SDL_Surface*) da_SDL_UnlockSurface;
	alias SDL_Surface* function(SDL_RWops*, int) da_SDL_LoadBMP_RW;
	alias int function(SDL_Surface*, SDL_RWops*, int) da_SDL_SaveBMP_RW;
	alias int function(SDL_Surface*, int) da_SDL_SetSurfaceRLE;
	alias int function(SDL_Surface*, int, Uint32) da_SDL_SetColorKey;
	alias int function(SDL_Surface*, Uint32*) da_SDL_GetColorKey;
	alias int function(SDL_Surface*, Uint8, Uint8, Uint8) da_SDL_SetSurfaceColorMod;
	alias int function(SDL_Surface*, Uint8*, Uint8*, Uint8*) da_SDL_GetSurfaceColorMod;
	alias int function(SDL_Surface*, Uint8) da_SDL_SetSurfaceAlphaMod;
	alias int function(SDL_Surface*, Uint8*) da_SDL_GetSurfaceAlphaMod;
	alias int function(SDL_Surface*, SDL_BlendMode) da_SDL_SetSurfaceBlendMode;
	alias int function(SDL_Surface*, SDL_BlendMode*) da_SDL_GetSurfaceBlendMode;
	alias SDL_bool function(SDL_Surface*, const(SDL_Rect)*) da_SDL_SetClipRect;
	alias void function(SDL_Surface*, SDL_Rect*) da_SDL_GetClipRect;
	alias SDL_Surface* function(SDL_Surface*, const(SDL_PixelFormat)*, Uint32) da_SDL_ConvertSurface;
	alias SDL_Surface* function(SDL_Surface*, Uint32, Uint32) da_SDL_ConvertSurfaceFormat;
	alias int function(int, int, Uint32, const(void)*, int, Uint32, void*, int) da_SDL_ConvertPixels;
	alias int function(SDL_Surface*, const(SDL_Rect)*, Uint32) da_SDL_FillRect;
	alias int function(SDL_Surface*, const(SDL_Rect)*, int, Uint32) da_SDL_FillRects;
	alias int function(SDL_Surface*, const(SDL_Rect)*, SDL_Surface*, SDL_Rect*) da_SDL_UpperBlit;
	alias int function(SDL_Surface*, SDL_Rect*, SDL_Surface*, SDL_Rect*) da_SDL_LowerBlit;
	alias int function(SDL_Surface*, const(SDL_Rect)*, SDL_Surface*, const(SDL_Rect)*) da_SDL_SoftStretch;
	alias int function(SDL_Surface*, const(SDL_Rect)*, SDL_Surface*, SDL_Rect*) da_SDL_UpperBlitScaled;
	alias int function(SDL_Surface*, SDL_Rect*, SDL_Surface*, SDL_Rect*) da_SDL_LowerBlitScaled;
	alias SDL_UpperBlit SDL_BlitSurface;
	alias SDL_UpperBlitScaled SDL_BlitScaled;
	static if (Derelict_OS_Windows)
	{
		alias int function(int) da_SDL_Direct3D9GetAdapterIndex;
		alias IDirect3DDevice9* function(SDL_Renderer*) da_SDL_RenderGetD3D9Device;
		alias void function(int, int*, int*) da_SDL_DXGIGetOutputInfo;
	}
	else
	{
		static if (Derelict_OS_iOS)
		{
			alias int function(SDL_Window*, int, SDL_iPhoneAnimationCallback, void*) da_SDL_iPhoneSetAnimationCallback;
			alias void function(SDL_bool) da_SDL_iPhoneSetEventPump;
		}
		else
		{
			static if (Derelict_OS_Android)
			{
				alias void* function() da_SDL_AndroidGetJNIEnv;
				alias void* function() da_SDL_AndroidGetActivity;
				alias const(char)* function() da_SDL_AndroidGetInternalStoragePath;
				alias int function() da_SDL_AndroidGetInternalStorageState;
				alias const(char)* function() da_SDL_AndroidGetExternalStoragePath;
			}
			else
			{
				static if (Derelict_OS_WinRT)
				{
					alias const(wchar_t)* function(SDL_WinRT_Path) da_SDL_WinRTGetFSPathUNICODE;
					alias const(char)* function(SDL_WinRT_Path) da_SDL_WinRTGetFSPathUTF8;
				}
			}
		}
	}
	alias SDL_bool function(SDL_Window* window, SDL_SysWMinfo* info) da_SDL_GetWindowWMInfo;
	alias Uint32 function() da_SDL_GetTicks;
	alias Uint64 function() da_SDL_GetPerformanceCounter;
	alias Uint64 function() da_SDL_GetPerformanceFrequency;
	alias void function(Uint32) da_SDL_Delay;
	alias SDL_TimerID function(Uint32, SDL_TimerCallback, void*) da_SDL_AddTimer;
	alias SDL_bool function(SDL_TimerID) da_SDL_RemoveTimer;
	alias int function() da_SDL_GetNumTouchDevices;
	alias SDL_TouchID function(int) da_SDL_GetTouchDevice;
	alias int function(SDL_TouchID) da_SDL_GetNumTouchFingers;
	alias SDL_Finger* function(SDL_TouchID, int) da_SDL_GetTouchFinger;
	alias void function(SDL_version*) da_SDL_GetVersion;
	alias const(char)* function() da_SDL_GetRevision;
	alias int function() da_SDL_GetRevisionNumber;
	alias int function() da_SDL_GetNumVideoDrivers;
	alias const(char)* function(int) da_SDL_GetVideoDriver;
	alias int function(const(char)*) da_SDL_VideoInit;
	alias void function() da_SDL_VideoQuit;
	alias const(char)* function() da_SDL_GetCurrentVideoDriver;
	alias int function() da_SDL_GetNumVideoDisplays;
	alias const(char)* function(int) da_SDL_GetDisplayName;
	alias int function(int, SDL_Rect*) da_SDL_GetDisplayBounds;
	alias int function(int) da_SDL_GetNumDisplayModes;
	alias int function(int, int, SDL_DisplayMode*) da_SDL_GetDisplayMode;
	alias int function(int, SDL_DisplayMode*) da_SDL_GetDesktopDisplayMode;
	alias int function(int, SDL_DisplayMode*) da_SDL_GetCurrentDisplayMode;
	alias SDL_DisplayMode* function(int, const(SDL_DisplayMode)*, SDL_DisplayMode*) da_SDL_GetClosestDisplayMode;
	alias int function(SDL_Window*) da_SDL_GetWindowDisplayIndex;
	alias int function(SDL_Window*, const(SDL_DisplayMode)*) da_SDL_SetWindowDisplayMode;
	alias int function(SDL_Window*, SDL_DisplayMode*) da_SDL_GetWindowDisplayMode;
	alias Uint32 function(SDL_Window*) da_SDL_GetWindowPixelFormat;
	alias SDL_Window* function(const(char)*, int, int, int, int, Uint32) da_SDL_CreateWindow;
	alias SDL_Window* function(const(void)*) da_SDL_CreateWindowFrom;
	alias Uint32 function(SDL_Window*) da_SDL_GetWindowID;
	alias SDL_Window* function(Uint32) da_SDL_GetWindowFromID;
	alias Uint32 function(SDL_Window*) da_SDL_GetWindowFlags;
	alias void function(SDL_Window*, const(char)*) da_SDL_SetWindowTitle;
	alias const(char)* function(SDL_Window*) da_SDL_GetWindowTitle;
	alias void function(SDL_Window*, SDL_Surface*) da_SDL_SetWindowIcon;
	alias void* function(SDL_Window*, const(char)*, void*) da_SDL_SetWindowData;
	alias void* function(SDL_Window*, const(char)*) da_SDL_GetWindowData;
	alias void function(SDL_Window*, int, int) da_SDL_SetWindowPosition;
	alias void function(SDL_Window*, int*, int*) da_SDL_GetWindowPosition;
	alias void function(SDL_Window*, int, int) da_SDL_SetWindowSize;
	alias void function(SDL_Window*, int*, int*) da_SDL_GetWindowSize;
	alias void function(SDL_Window*, int, int) da_SDL_SetWindowMinimumSize;
	alias void function(SDL_Window*, int*, int*) da_SDL_GetWindowMinimumSize;
	alias void function(SDL_Window*, int, int) da_SDL_SetWindowMaximumSize;
	alias void function(SDL_Window*, int*, int*) da_SDL_GetWindowMaximumSize;
	alias void function(SDL_Window*, SDL_bool) da_SDL_SetWindowBordered;
	alias void function(SDL_Window*) da_SDL_ShowWindow;
	alias void function(SDL_Window*) da_SDL_HideWindow;
	alias void function(SDL_Window*) da_SDL_RaiseWindow;
	alias void function(SDL_Window*) da_SDL_MaximizeWindow;
	alias void function(SDL_Window*) da_SDL_MinimizeWindow;
	alias void function(SDL_Window*) da_SDL_RestoreWindow;
	alias int function(SDL_Window*, Uint32) da_SDL_SetWindowFullscreen;
	alias SDL_Surface* function(SDL_Window*) da_SDL_GetWindowSurface;
	alias int function(SDL_Window*) da_SDL_UpdateWindowSurface;
	alias int function(SDL_Window*, SDL_Rect*, int) da_SDL_UpdateWindowSurfaceRects;
	alias void function(SDL_Window*, SDL_bool) da_SDL_SetWindowGrab;
	alias SDL_bool function(SDL_Window*) da_SDL_GetWindowGrab;
	alias int function(SDL_Window*, float) da_SDL_SetWindowBrightness;
	alias float function(SDL_Window*) da_SDL_GetWindowBrightness;
	alias int function(SDL_Window*, const(Uint16)*, const(Uint16)*, const(Uint16)*, const(Uint16)*) da_SDL_SetWindowGammaRamp;
	alias int function(SDL_Window*, Uint16*, Uint16*, Uint16*, Uint16*) da_SDL_GetWindowGammaRamp;
	alias void function(SDL_Window*) da_SDL_DestroyWindow;
	alias SDL_bool function() da_SDL_IsScreenSaverEnabled;
	alias void function() da_SDL_EnableScreenSaver;
	alias void function() da_SDL_DisableScreenSaver;
	alias int function(const(char)*) da_SDL_GL_LoadLibrary;
	alias void* function(const(char)*) da_SDL_GL_GetProcAddress;
	alias void function() da_SDL_GL_UnloadLibrary;
	alias SDL_bool function(const(char)*) da_SDL_GL_ExtensionSupported;
	alias void function() da_SDL_GL_ResetAttributes;
	alias int function(SDL_GLattr, int) da_SDL_GL_SetAttribute;
	alias int function(SDL_GLattr, int*) da_SDL_GL_GetAttribute;
	alias SDL_GLContext function(SDL_Window*) da_SDL_GL_CreateContext;
	alias int function(SDL_Window*, SDL_GLContext) da_SDL_GL_MakeCurrent;
	alias SDL_Window* function() da_SDL_GL_GetCurrentWindow;
	alias SDL_GLContext function() da_SDL_GL_GetCurrentContext;
	alias void function(SDL_Window*, int*, int*) da_SDL_GL_GetDrawableSize;
	alias int function(int) da_SDL_GL_SetSwapInterval;
	alias int function() da_SDL_GL_GetSwapInterval;
	alias void function(SDL_Window*) da_SDL_GL_SwapWindow;
	alias void function(SDL_GLContext) da_SDL_GL_DeleteContext;
	alias char* function() da_SDL_GetBasePath;
	alias char* function(const(char)* org, const(char)* app) da_SDL_GetPrefPath;
}

nothrow @nogc 
{
	SDL_AudioSpec* SDL_LoadWAV(const(char)* file, SDL_AudioSpec* spec, Uint8** audio_buf, Uint32* len);
	Uint8 SDL_GetEventState(Uint32 type);
	int SDL_GameControllerAddMappingsFromFile(const(char)* file);
	bool SDL_QuitRequested();
	SDL_Surface* SDL_LoadBMP(const(char)* file);
	int SDL_SaveBMP(SDL_Surface* surface, const(char)* file);
}
__gshared 
{
	da_SDL_Init SDL_Init;
	da_SDL_InitSubSystem SDL_InitSubSystem;
	da_SDL_QuitSubSystem SDL_QuitSubSystem;
	da_SDL_WasInit SDL_WasInit;
	da_SDL_Quit SDL_Quit;
	da_SDL_free SDL_free;
	da_SDL_SetAssertionHandler SDL_SetAssertionHandler;
	da_SDL_GetAssertionReport SDL_GetAssertionReport;
	da_SDL_ResetAssertionReport SDL_ResetAssertionReport;
	da_SDL_GetNumAudioDrivers SDL_GetNumAudioDrivers;
	da_SDL_GetAudioDriver SDL_GetAudioDriver;
	da_SDL_AudioInit SDL_AudioInit;
	da_SDL_AudioQuit SDL_AudioQuit;
	da_SDL_GetCurrentAudioDriver SDL_GetCurrentAudioDriver;
	da_SDL_OpenAudio SDL_OpenAudio;
	da_SDL_GetNumAudioDevices SDL_GetNumAudioDevices;
	da_SDL_GetAudioDeviceName SDL_GetAudioDeviceName;
	da_SDL_OpenAudioDevice SDL_OpenAudioDevice;
	da_SDL_GetAudioStatus SDL_GetAudioStatus;
	da_SDL_GetAudioDeviceStatus SDL_GetAudioDeviceStatus;
	da_SDL_PauseAudio SDL_PauseAudio;
	da_SDL_PauseAudioDevice SDL_PauseAudioDevice;
	da_SDL_LoadWAV_RW SDL_LoadWAV_RW;
	da_SDL_FreeWAV SDL_FreeWAV;
	da_SDL_BuildAudioCVT SDL_BuildAudioCVT;
	da_SDL_ConvertAudio SDL_ConvertAudio;
	da_SDL_MixAudio SDL_MixAudio;
	da_SDL_MixAudioFormat SDL_MixAudioFormat;
	da_SDL_LockAudio SDL_LockAudio;
	da_SDL_LockAudioDevice SDL_LockAudioDevice;
	da_SDL_UnlockAudio SDL_UnlockAudio;
	da_SDL_UnlockAudioDevice SDL_UnlockAudioDevice;
	da_SDL_CloseAudio SDL_CloseAudio;
	da_SDL_CloseAudioDevice SDL_CloseAudioDevice;
	da_SDL_SetClipboardText SDL_SetClipboardText;
	da_SDL_GetClipboardText SDL_GetClipboardText;
	da_SDL_HasClipboardText SDL_HasClipboardText;
	da_SDL_GetCPUCount SDL_GetCPUCount;
	da_SDL_GetCPUCacheLineSize SDL_GetCPUCacheLineSize;
	da_SDL_HasRDTSC SDL_HasRDTSC;
	da_SDL_HasAltiVec SDL_HasAltiVec;
	da_SDL_HasMMX SDL_HasMMX;
	da_SDL_Has3DNow SDL_Has3DNow;
	da_SDL_HasSSE SDL_HasSSE;
	da_SDL_HasSSE2 SDL_HasSSE2;
	da_SDL_HasSSE3 SDL_HasSSE3;
	da_SDL_HasSSE41 SDL_HasSSE41;
	da_SDL_HasSSE42 SDL_HasSSE42;
	da_SDL_HasAVX SDL_HasAVX;
	da_SDL_GetSystemRAM SDL_GetSystemRAM;
	da_SDL_SetError SDL_SetError;
	da_SDL_GetError SDL_GetError;
	da_SDL_ClearError SDL_ClearError;
	da_SDL_PumpEvents SDL_PumpEvents;
	da_SDL_PeepEvents SDL_PeepEvents;
	da_SDL_HasEvent SDL_HasEvent;
	da_SDL_HasEvents SDL_HasEvents;
	da_SDL_FlushEvent SDL_FlushEvent;
	da_SDL_FlushEvents SDL_FlushEvents;
	da_SDL_PollEvent SDL_PollEvent;
	da_SDL_WaitEvent SDL_WaitEvent;
	da_SDL_WaitEventTimeout SDL_WaitEventTimeout;
	da_SDL_PushEvent SDL_PushEvent;
	da_SDL_SetEventFilter SDL_SetEventFilter;
	da_SDL_GetEventFilter SDL_GetEventFilter;
	da_SDL_AddEventWatch SDL_AddEventWatch;
	da_SDL_DelEventWatch SDL_DelEventWatch;
	da_SDL_FilterEvents SDL_FilterEvents;
	da_SDL_EventState SDL_EventState;
	da_SDL_RegisterEvents SDL_RegisterEvents;
	da_SDL_GameControllerAddMappingsFromRW SDL_GameControllerAddMappingsFromRW;
	da_SDL_GameControllerAddMapping SDL_GameControllerAddMapping;
	da_SDL_GameControllerMappingForGUID SDL_GameControllerMappingForGUID;
	da_SDL_GameControllerMapping SDL_GameControllerMapping;
	da_SDL_IsGameController SDL_IsGameController;
	da_SDL_GameControllerNameForIndex SDL_GameControllerNameForIndex;
	da_SDL_GameControllerOpen SDL_GameControllerOpen;
	da_SDL_GameControllerName SDL_GameControllerName;
	da_SDL_GameControllerGetAttached SDL_GameControllerGetAttached;
	da_SDL_GameControllerGetJoystick SDL_GameControllerGetJoystick;
	da_SDL_GameControllerEventState SDL_GameControllerEventState;
	da_SDL_GameControllerUpdate SDL_GameControllerUpdate;
	da_SDL_GameControllerGetAxisFromString SDL_GameControllerGetAxisFromString;
	da_SDL_GameControllerGetStringForAxis SDL_GameControllerGetStringForAxis;
	da_SDL_GameControllerGetBindForAxis SDL_GameControllerGetBindForAxis;
	da_SDL_GameControllerGetAxis SDL_GameControllerGetAxis;
	da_SDL_GameControllerGetButtonFromString SDL_GameControllerGetButtonFromString;
	da_SDL_GameControllerGetStringForButton SDL_GameControllerGetStringForButton;
	da_SDL_GameControllerGetBindForButton SDL_GameControllerGetBindForButton;
	da_SDL_GameControllerGetButton SDL_GameControllerGetButton;
	da_SDL_GameControllerClose SDL_GameControllerClose;
	da_SDL_RecordGesture SDL_RecordGesture;
	da_SDL_SaveAllDollarTemplates SDL_SaveAllDollarTemplates;
	da_SDL_SaveDollarTemplate SDL_SaveDollarTemplate;
	da_SDL_LoadDollarTemplates SDL_LoadDollarTemplates;
	da_SDL_NumHaptics SDL_NumHaptics;
	da_SDL_HapticName SDL_HapticName;
	da_SDL_HapticOpen SDL_HapticOpen;
	da_SDL_HapticOpened SDL_HapticOpened;
	da_SDL_HapticIndex SDL_HapticIndex;
	da_SDL_MouseIsHaptic SDL_MouseIsHaptic;
	da_SDL_HapticOpenFromMouse SDL_HapticOpenFromMouse;
	da_SDL_JoystickIsHaptic SDL_JoystickIsHaptic;
	da_SDL_HapticOpenFromJoystick SDL_HapticOpenFromJoystick;
	da_SDL_HapticClose SDL_HapticClose;
	da_SDL_HapticNumEffects SDL_HapticNumEffects;
	da_SDL_HapticNumEffectsPlaying SDL_HapticNumEffectsPlaying;
	da_SDL_HapticQuery SDL_HapticQuery;
	da_SDL_HapticNumAxes SDL_HapticNumAxes;
	da_SDL_HapticEffectSupported SDL_HapticEffectSupported;
	da_SDL_HapticNewEffect SDL_HapticNewEffect;
	da_SDL_HapticUpdateEffect SDL_HapticUpdateEffect;
	da_SDL_HapticRunEffect SDL_HapticRunEffect;
	da_SDL_HapticStopEffect SDL_HapticStopEffect;
	da_SDL_HapticDestroyEffect SDL_HapticDestroyEffect;
	da_SDL_HapticGetEffectStatus SDL_HapticGetEffectStatus;
	da_SDL_HapticSetGain SDL_HapticSetGain;
	da_SDL_HapticSetAutocenter SDL_HapticSetAutocenter;
	da_SDL_HapticPause SDL_HapticPause;
	da_SDL_HapticUnpause SDL_HapticUnpause;
	da_SDL_HapticStopAll SDL_HapticStopAll;
	da_SDL_HapticRumbleSupported SDL_HapticRumbleSupported;
	da_SDL_HapticRumbleInit SDL_HapticRumbleInit;
	da_SDL_HapticRumblePlay SDL_HapticRumblePlay;
	da_SDL_HapticRumbleStop SDL_HapticRumbleStop;
	da_SDL_SetHintWithPriority SDL_SetHintWithPriority;
	da_SDL_SetHint SDL_SetHint;
	da_SDL_GetHint SDL_GetHint;
	da_SDL_AddHintCallback SDL_AddHintCallback;
	da_SDL_DelHintCallback SDL_DelHintCallback;
	da_SDL_ClearHints SDL_ClearHints;
	da_SDL_IsDeviceDisconnected SDL_IsDeviceDisconnected;
	da_SDL_NumJoysticks SDL_NumJoysticks;
	da_SDL_JoystickNameForIndex SDL_JoystickNameForIndex;
	da_SDL_JoystickOpen SDL_JoystickOpen;
	da_SDL_JoystickName SDL_JoystickName;
	da_SDL_JoystickGetDeviceGUID SDL_JoystickGetDeviceGUID;
	da_SDL_JoystickGetGUID SDL_JoystickGetGUID;
	da_SDL_JoystickGetGUIDString SDL_JoystickGetGUIDString;
	da_SDL_JoystickGetGUIDFromString SDL_JoystickGetGUIDFromString;
	da_SDL_JoystickGetAttached SDL_JoystickGetAttached;
	da_SDL_JoystickInstanceID SDL_JoystickInstanceID;
	da_SDL_JoystickNumAxes SDL_JoystickNumAxes;
	da_SDL_JoystickNumBalls SDL_JoystickNumBalls;
	da_SDL_JoystickNumHats SDL_JoystickNumHats;
	da_SDL_JoystickNumButtons SDL_JoystickNumButtons;
	da_SDL_JoystickUpdate SDL_JoystickUpdate;
	da_SDL_JoystickEventState SDL_JoystickEventState;
	da_SDL_JoystickGetAxis SDL_JoystickGetAxis;
	da_SDL_JoystickGetHat SDL_JoystickGetHat;
	da_SDL_JoystickGetBall SDL_JoystickGetBall;
	da_SDL_JoystickGetButton SDL_JoystickGetButton;
	da_SDL_JoystickClose SDL_JoystickClose;
	da_SDL_GetKeyboardFocus SDL_GetKeyboardFocus;
	da_SDL_GetKeyboardState SDL_GetKeyboardState;
	da_SDL_GetModState SDL_GetModState;
	da_SDL_SetModState SDL_SetModState;
	da_SDL_GetKeyFromScancode SDL_GetKeyFromScancode;
	da_SDL_GetScancodeFromKey SDL_GetScancodeFromKey;
	da_SDL_GetScancodeName SDL_GetScancodeName;
	da_SDL_GetScancodeFromName SDL_GetScancodeFromName;
	da_SDL_GetKeyName SDL_GetKeyName;
	da_SDL_GetKeyFromName SDL_GetKeyFromName;
	da_SDL_StartTextInput SDL_StartTextInput;
	da_SDL_IsTextInputActive SDL_IsTextInputActive;
	da_SDL_StopTextInput SDL_StopTextInput;
	da_SDL_SetTextInputRect SDL_SetTextInputRect;
	da_SDL_HasScreenKeyboardSupport SDL_HasScreenKeyboardSupport;
	da_SDL_IsScreenKeyboardShown SDL_IsScreenKeyboardShown;
	da_SDL_LoadObject SDL_LoadObject;
	da_SDL_LoadFunction SDL_LoadFunction;
	da_SDL_UnloadObject SDL_UnloadObject;
	da_SDL_LogSetAllPriority SDL_LogSetAllPriority;
	da_SDL_LogSetPriority SDL_LogSetPriority;
	da_SDL_LogGetPriority SDL_LogGetPriority;
	da_SDL_LogResetPriorities SDL_LogResetPriorities;
	da_SDL_Log SDL_Log;
	da_SDL_LogVerbose SDL_LogVerbose;
	da_SDL_LogDebug SDL_LogDebug;
	da_SDL_LogInfo SDL_LogInfo;
	da_SDL_LogWarn SDL_LogWarn;
	da_SDL_LogError SDL_LogError;
	da_SDL_LogCritical SDL_LogCritical;
	da_SDL_LogMessage SDL_LogMessage;
	da_SDL_LogMessageV SDL_LogMessageV;
	da_SDL_LogGetOutputFunction SDL_LogGetOutputFunction;
	da_SDL_LogSetOutputFunction SDL_LogSetOutputFunction;
	da_SDL_ShowMessageBox SDL_ShowMessageBox;
	da_SDL_ShowSimpleMessageBox SDL_ShowSimpleMessageBox;
	da_SDL_GetMouseFocus SDL_GetMouseFocus;
	da_SDL_GetMouseState SDL_GetMouseState;
	da_SDL_GetRelativeMouseState SDL_GetRelativeMouseState;
	da_SDL_WarpMouseInWindow SDL_WarpMouseInWindow;
	da_SDL_SetRelativeMouseMode SDL_SetRelativeMouseMode;
	da_SDL_GetRelativeMouseMode SDL_GetRelativeMouseMode;
	da_SDL_CreateCursor SDL_CreateCursor;
	da_SDL_CreateColorCursor SDL_CreateColorCursor;
	da_SDL_CreateSystemCursor SDL_CreateSystemCursor;
	da_SDL_SetCursor SDL_SetCursor;
	da_SDL_GetCursor SDL_GetCursor;
	da_SDL_GetDefaultCursor SDL_GetDefaultCursor;
	da_SDL_FreeCursor SDL_FreeCursor;
	da_SDL_ShowCursor SDL_ShowCursor;
	da_SDL_GetPixelFormatName SDL_GetPixelFormatName;
	da_SDL_PixelFormatEnumToMasks SDL_PixelFormatEnumToMasks;
	da_SDL_MasksToPixelFormatEnum SDL_MasksToPixelFormatEnum;
	da_SDL_AllocFormat SDL_AllocFormat;
	da_SDL_FreeFormat SDL_FreeFormat;
	da_SDL_AllocPalette SDL_AllocPalette;
	da_SDL_SetPixelFormatPalette SDL_SetPixelFormatPalette;
	da_SDL_SetPaletteColors SDL_SetPaletteColors;
	da_SDL_FreePalette SDL_FreePalette;
	da_SDL_MapRGB SDL_MapRGB;
	da_SDL_MapRGBA SDL_MapRGBA;
	da_SDL_GetRGB SDL_GetRGB;
	da_SDL_GetRGBA SDL_GetRGBA;
	da_SDL_CalculateGammaRamp SDL_CalculateGammaRamp;
	da_SDL_GetPlatform SDL_GetPlatform;
	da_SDL_GetPowerInfo SDL_GetPowerInfo;
	da_SDL_HasIntersection SDL_HasIntersection;
	da_SDL_IntersectRect SDL_IntersectRect;
	da_SDL_UnionRect SDL_UnionRect;
	da_SDL_EnclosePoints SDL_EnclosePoints;
	da_SDL_IntersectRectAndLine SDL_IntersectRectAndLine;
	da_SDL_GetNumRenderDrivers SDL_GetNumRenderDrivers;
	da_SDL_GetRenderDriverInfo SDL_GetRenderDriverInfo;
	da_SDL_CreateWindowAndRenderer SDL_CreateWindowAndRenderer;
	da_SDL_CreateRenderer SDL_CreateRenderer;
	da_SDL_CreateSoftwareRenderer SDL_CreateSoftwareRenderer;
	da_SDL_GetRenderer SDL_GetRenderer;
	da_SDL_GetRendererInfo SDL_GetRendererInfo;
	da_SDL_GetRendererOutputSize SDL_GetRendererOutputSize;
	da_SDL_CreateTexture SDL_CreateTexture;
	da_SDL_CreateTextureFromSurface SDL_CreateTextureFromSurface;
	da_SDL_QueryTexture SDL_QueryTexture;
	da_SDL_SetTextureColorMod SDL_SetTextureColorMod;
	da_SDL_GetTextureColorMod SDL_GetTextureColorMod;
	da_SDL_SetTextureAlphaMod SDL_SetTextureAlphaMod;
	da_SDL_GetTextureAlphaMod SDL_GetTextureAlphaMod;
	da_SDL_SetTextureBlendMode SDL_SetTextureBlendMode;
	da_SDL_GetTextureBlendMode SDL_GetTextureBlendMode;
	da_SDL_UpdateTexture SDL_UpdateTexture;
	da_SDL_UpdateYUVTexture SDL_UpdateYUVTexture;
	da_SDL_LockTexture SDL_LockTexture;
	da_SDL_UnlockTexture SDL_UnlockTexture;
	da_SDL_RenderTargetSupported SDL_RenderTargetSupported;
	da_SDL_SetRenderTarget SDL_SetRenderTarget;
	da_SDL_GetRenderTarget SDL_GetRenderTarget;
	da_SDL_RenderSetClipRect SDL_RenderSetClipRect;
	da_SDL_RenderGetClipRect SDL_RenderGetClipRect;
	da_SDL_RenderSetLogicalSize SDL_RenderSetLogicalSize;
	da_SDL_RenderGetLogicalSize SDL_RenderGetLogicalSize;
	da_SDL_RenderSetViewport SDL_RenderSetViewport;
	da_SDL_RenderGetViewport SDL_RenderGetViewport;
	da_SDL_RenderSetScale SDL_RenderSetScale;
	da_SDL_RenderGetScale SDL_RenderGetScale;
	da_SDL_SetRenderDrawColor SDL_SetRenderDrawColor;
	da_SDL_GetRenderDrawColor SDL_GetRenderDrawColor;
	da_SDL_SetRenderDrawBlendMode SDL_SetRenderDrawBlendMode;
	da_SDL_GetRenderDrawBlendMode SDL_GetRenderDrawBlendMode;
	da_SDL_RenderClear SDL_RenderClear;
	da_SDL_RenderDrawPoint SDL_RenderDrawPoint;
	da_SDL_RenderDrawPoints SDL_RenderDrawPoints;
	da_SDL_RenderDrawLine SDL_RenderDrawLine;
	da_SDL_RenderDrawLines SDL_RenderDrawLines;
	da_SDL_RenderDrawRect SDL_RenderDrawRect;
	da_SDL_RenderDrawRects SDL_RenderDrawRects;
	da_SDL_RenderFillRect SDL_RenderFillRect;
	da_SDL_RenderFillRects SDL_RenderFillRects;
	da_SDL_RenderCopy SDL_RenderCopy;
	da_SDL_RenderCopyEx SDL_RenderCopyEx;
	da_SDL_RenderReadPixels SDL_RenderReadPixels;
	da_SDL_RenderPresent SDL_RenderPresent;
	da_SDL_DestroyTexture SDL_DestroyTexture;
	da_SDL_DestroyRenderer SDL_DestroyRenderer;
	da_SDL_GL_BindTexture SDL_GL_BindTexture;
	da_SDL_GL_UnbindTexture SDL_GL_UnbindTexture;
	da_SDL_RWFromFile SDL_RWFromFile;
	da_SDL_RWFromFP SDL_RWFromFP;
	da_SDL_RWFromMem SDL_RWFromMem;
	da_SDL_RWFromConstMem SDL_RWFromConstMem;
	da_SDL_AllocRW SDL_AllocRW;
	da_SDL_FreeRW SDL_FreeRW;
	da_SDL_ReadU8 SDL_ReadU8;
	da_SDL_ReadLE16 SDL_ReadLE16;
	da_SDL_ReadBE16 SDL_ReadBE16;
	da_SDL_ReadLE32 SDL_ReadLE32;
	da_SDL_ReadBE32 SDL_ReadBE32;
	da_SDL_ReadLE64 SDL_ReadLE64;
	da_SDL_ReadBE64 SDL_ReadBE64;
	da_SDL_WriteU8 SDL_WriteU8;
	da_SDL_WriteLE16 SDL_WriteLE16;
	da_SDL_WriteBE16 SDL_WriteBE16;
	da_SDL_WriteLE32 SDL_WriteLE32;
	da_SDL_WriteBE32 SDL_WriteBE32;
	da_SDL_WriteLE64 SDL_WriteLE64;
	da_SDL_WriteBE64 SDL_WriteBE64;
	da_SDL_CreateShapedWindow SDL_CreateShapedWindow;
	da_SDL_IsShapedWindow SDL_IsShapedWindow;
	da_SDL_SetWindowShape SDL_SetWindowShape;
	da_SDL_GetShapedWindowMode SDL_GetShapedWindowMode;
	da_SDL_CreateRGBSurface SDL_CreateRGBSurface;
	da_SDL_CreateRGBSurfaceFrom SDL_CreateRGBSurfaceFrom;
	da_SDL_FreeSurface SDL_FreeSurface;
	da_SDL_SetSurfacePalette SDL_SetSurfacePalette;
	da_SDL_LockSurface SDL_LockSurface;
	da_SDL_UnlockSurface SDL_UnlockSurface;
	da_SDL_LoadBMP_RW SDL_LoadBMP_RW;
	da_SDL_SaveBMP_RW SDL_SaveBMP_RW;
	da_SDL_SetSurfaceRLE SDL_SetSurfaceRLE;
	da_SDL_SetColorKey SDL_SetColorKey;
	da_SDL_GetColorKey SDL_GetColorKey;
	da_SDL_SetSurfaceColorMod SDL_SetSurfaceColorMod;
	da_SDL_GetSurfaceColorMod SDL_GetSurfaceColorMod;
	da_SDL_SetSurfaceAlphaMod SDL_SetSurfaceAlphaMod;
	da_SDL_GetSurfaceAlphaMod SDL_GetSurfaceAlphaMod;
	da_SDL_SetSurfaceBlendMode SDL_SetSurfaceBlendMode;
	da_SDL_GetSurfaceBlendMode SDL_GetSurfaceBlendMode;
	da_SDL_SetClipRect SDL_SetClipRect;
	da_SDL_GetClipRect SDL_GetClipRect;
	da_SDL_ConvertSurface SDL_ConvertSurface;
	da_SDL_ConvertSurfaceFormat SDL_ConvertSurfaceFormat;
	da_SDL_ConvertPixels SDL_ConvertPixels;
	da_SDL_FillRect SDL_FillRect;
	da_SDL_FillRects SDL_FillRects;
	da_SDL_UpperBlit SDL_UpperBlit;
	da_SDL_LowerBlit SDL_LowerBlit;
	da_SDL_SoftStretch SDL_SoftStretch;
	da_SDL_UpperBlitScaled SDL_UpperBlitScaled;
	da_SDL_LowerBlitScaled SDL_LowerBlitScaled;
	static if (Derelict_OS_Windows)
	{
		da_SDL_Direct3D9GetAdapterIndex SDL_Direct3D9GetAdapterIndex;
		da_SDL_RenderGetD3D9Device SDL_RenderGetD3D9Device;
		da_SDL_DXGIGetOutputInfo SDL_DXGIGetOutputInfo;
	}
	else
	{
		static if (Derelict_OS_iOS)
		{
			da_SDL_iPhoneSetAnimationCallback SDL_iPhoneSetAnimationCallback;
			da_SDL_iPhoneSetEventPump SDL_iPhoneSetEventPump;
		}
		else
		{
			static if (Derelict_OS_Android)
			{
				da_SDL_AndroidGetJNIEnv SDL_AndroidGetJNIEnv;
				da_SDL_AndroidGetActivity SDL_AndroidGetActivity;
				da_SDL_AndroidGetInternalStoragePath SDL_AndroidGetInternalStoragePath;
				da_SDL_AndroidGetInternalStorageState SDL_AndroidGetInternalStorageState;
				da_SDL_AndroidGetExternalStoragePath SDL_AndroidGetExternalStoragePath;
			}
			else
			{
				static if (Derelict_OS_WinRT)
				{
					da_SDL_WinRTGetFSPathUNICODE SDL_WinRTGetFSPathUNICODE;
					da_SDL_WinRTGetFSPathUTF8 SDL_WinRTGetFSPathUTF8;
				}
			}
		}
	}
	da_SDL_GetWindowWMInfo SDL_GetWindowWMInfo;
	da_SDL_GetTicks SDL_GetTicks;
	da_SDL_GetPerformanceCounter SDL_GetPerformanceCounter;
	da_SDL_GetPerformanceFrequency SDL_GetPerformanceFrequency;
	da_SDL_Delay SDL_Delay;
	da_SDL_AddTimer SDL_AddTimer;
	da_SDL_RemoveTimer SDL_RemoveTimer;
	da_SDL_GetNumTouchDevices SDL_GetNumTouchDevices;
	da_SDL_GetTouchDevice SDL_GetTouchDevice;
	da_SDL_GetNumTouchFingers SDL_GetNumTouchFingers;
	da_SDL_GetTouchFinger SDL_GetTouchFinger;
	da_SDL_GetVersion SDL_GetVersion;
	da_SDL_GetRevision SDL_GetRevision;
	da_SDL_GetRevisionNumber SDL_GetRevisionNumber;
	da_SDL_GetNumVideoDrivers SDL_GetNumVideoDrivers;
	da_SDL_GetVideoDriver SDL_GetVideoDriver;
	da_SDL_VideoInit SDL_VideoInit;
	da_SDL_VideoQuit SDL_VideoQuit;
	da_SDL_GetCurrentVideoDriver SDL_GetCurrentVideoDriver;
	da_SDL_GetNumVideoDisplays SDL_GetNumVideoDisplays;
	da_SDL_GetDisplayName SDL_GetDisplayName;
	da_SDL_GetDisplayBounds SDL_GetDisplayBounds;
	da_SDL_GetNumDisplayModes SDL_GetNumDisplayModes;
	da_SDL_GetDisplayMode SDL_GetDisplayMode;
	da_SDL_GetDesktopDisplayMode SDL_GetDesktopDisplayMode;
	da_SDL_GetCurrentDisplayMode SDL_GetCurrentDisplayMode;
	da_SDL_GetClosestDisplayMode SDL_GetClosestDisplayMode;
	da_SDL_GetWindowDisplayIndex SDL_GetWindowDisplayIndex;
	da_SDL_SetWindowDisplayMode SDL_SetWindowDisplayMode;
	da_SDL_GetWindowDisplayMode SDL_GetWindowDisplayMode;
	da_SDL_GetWindowPixelFormat SDL_GetWindowPixelFormat;
	da_SDL_CreateWindow SDL_CreateWindow;
	da_SDL_CreateWindowFrom SDL_CreateWindowFrom;
	da_SDL_GetWindowID SDL_GetWindowID;
	da_SDL_GetWindowFromID SDL_GetWindowFromID;
	da_SDL_GetWindowFlags SDL_GetWindowFlags;
	da_SDL_SetWindowTitle SDL_SetWindowTitle;
	da_SDL_GetWindowTitle SDL_GetWindowTitle;
	da_SDL_SetWindowIcon SDL_SetWindowIcon;
	da_SDL_SetWindowData SDL_SetWindowData;
	da_SDL_GetWindowData SDL_GetWindowData;
	da_SDL_SetWindowPosition SDL_SetWindowPosition;
	da_SDL_GetWindowPosition SDL_GetWindowPosition;
	da_SDL_SetWindowSize SDL_SetWindowSize;
	da_SDL_GetWindowSize SDL_GetWindowSize;
	da_SDL_SetWindowMinimumSize SDL_SetWindowMinimumSize;
	da_SDL_GetWindowMinimumSize SDL_GetWindowMinimumSize;
	da_SDL_SetWindowMaximumSize SDL_SetWindowMaximumSize;
	da_SDL_GetWindowMaximumSize SDL_GetWindowMaximumSize;
	da_SDL_SetWindowBordered SDL_SetWindowBordered;
	da_SDL_ShowWindow SDL_ShowWindow;
	da_SDL_HideWindow SDL_HideWindow;
	da_SDL_RaiseWindow SDL_RaiseWindow;
	da_SDL_MaximizeWindow SDL_MaximizeWindow;
	da_SDL_MinimizeWindow SDL_MinimizeWindow;
	da_SDL_RestoreWindow SDL_RestoreWindow;
	da_SDL_SetWindowFullscreen SDL_SetWindowFullscreen;
	da_SDL_GetWindowSurface SDL_GetWindowSurface;
	da_SDL_UpdateWindowSurface SDL_UpdateWindowSurface;
	da_SDL_UpdateWindowSurfaceRects SDL_UpdateWindowSurfaceRects;
	da_SDL_SetWindowGrab SDL_SetWindowGrab;
	da_SDL_GetWindowGrab SDL_GetWindowGrab;
	da_SDL_SetWindowBrightness SDL_SetWindowBrightness;
	da_SDL_GetWindowBrightness SDL_GetWindowBrightness;
	da_SDL_SetWindowGammaRamp SDL_SetWindowGammaRamp;
	da_SDL_GetWindowGammaRamp SDL_GetWindowGammaRamp;
	da_SDL_DestroyWindow SDL_DestroyWindow;
	da_SDL_IsScreenSaverEnabled SDL_IsScreenSaverEnabled;
	da_SDL_EnableScreenSaver SDL_EnableScreenSaver;
	da_SDL_DisableScreenSaver SDL_DisableScreenSaver;
	da_SDL_GL_LoadLibrary SDL_GL_LoadLibrary;
	da_SDL_GL_GetProcAddress SDL_GL_GetProcAddress;
	da_SDL_GL_UnloadLibrary SDL_GL_UnloadLibrary;
	da_SDL_GL_ExtensionSupported SDL_GL_ExtensionSupported;
	da_SDL_GL_ResetAttributes SDL_GL_ResetAttributes;
	da_SDL_GL_SetAttribute SDL_GL_SetAttribute;
	da_SDL_GL_GetAttribute SDL_GL_GetAttribute;
	da_SDL_GL_CreateContext SDL_GL_CreateContext;
	da_SDL_GL_MakeCurrent SDL_GL_MakeCurrent;
	da_SDL_GL_GetCurrentWindow SDL_GL_GetCurrentWindow;
	da_SDL_GL_GetCurrentContext SDL_GL_GetCurrentContext;
	da_SDL_GL_GetDrawableSize SDL_GL_GetDrawableSize;
	da_SDL_GL_SetSwapInterval SDL_GL_SetSwapInterval;
	da_SDL_GL_GetSwapInterval SDL_GL_GetSwapInterval;
	da_SDL_GL_SwapWindow SDL_GL_SwapWindow;
	da_SDL_GL_DeleteContext SDL_GL_DeleteContext;
	da_SDL_GetBasePath SDL_GetBasePath;
	da_SDL_GetPrefPath SDL_GetPrefPath;
}
